--Group Specific stuffs
-----------------------



function rltext.UpdateList()
	if rltext.scrollList then
		rltext.scrollList:RefreshData()
	end
end

function rltext.saveSecondary()
	if not(rltext:ActiveSettings().savesec) then return end

	local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

	if not(leadName == rltext.player) then return end

	local slist = {}
	for k,v in pairs(rltext.masterList) do
		if v.issec then
			table.insert(slist,k)
		end
	end
	--i feel like i'm being stupid
	for k,v in pairs(rltext:ActiveSettings().savedSec) do
        if not(rltext.tableHasValue(slist, v)) then
            table.insert(slist,v)
        end
	end
	rltext:ActiveSettings().savedSec = slist
end


function rltext.UpdateGroup()
	if not(rltext.masterList) then return end

	local savedNames = {}

	for i=1,GetGroupSize() do
        local tag = GetGroupUnitTagByIndex(i)
        local name = GetUnitName(tag)
        savedNames[name] = true
    end

    for k,v in pairs(rltext.masterList) do
    	if not(savedNames[k]) then
    		rltext.masterList[k] = nil
    	end
    end

    local newLeader = GetGroupLeaderUnitTag()
	local leadName = GetUnitName(newLeader)

    for i=1,GetGroupSize() do
        local tag = GetGroupUnitTagByIndex(i)
        local name = GetUnitName(tag)

		local isTalk = (name==leadName)
		local isSec = rltext.tableHasValue(rltext:ActiveSettings().savedSec, name)

		if not(rltext:ActiveSettings().savesec) or not(leadName == rltext.player)  then
			isSec = false
		end

		if not(rltext.masterList[name]) then
        	rltext.masterList[name] = {['cantalk'] = isTalk, ['issec'] = isSec}
        else
        	if rltext.masterList[name].cantalk and not(leadName == name) then
        		if rltext.lastLead == name then
        			rltext.masterList[name].cantalk = false
        		end
        	else
        		if leadName == name then
        			rltext.masterList[name].cantalk = true
        		end
        	end
        end

        --if we're the new leader we need to set secondaries
        if rltext:ActiveSettings().savesec then
        	if not(rltext.lastLead == leadName) and (leadName == rltext.player) then
        		rltext.masterList[name].issec = rltext.tableHasValue(rltext:ActiveSettings().savedSec, name)
        	end
        end
    end

    --remove sec of new lead if any
    if string.len(leadName) > 0 then
        rltext.masterList[leadName].issec = false
    end

	rltext.lastLead = leadName

    if GetGroupSize() < 2 then
		rltext.SecButton:SetHidden(true)
	else
		rltext.SecButton:SetHidden(false)
	end

    rltext.HideCheck()
    rltext.UpdateList()
end

function rltext.InitialUpdate()
	rltext.UpdateGroup()
end

EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_LEADER_UPDATE, rltext.UpdateGroup)
EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_GROUP_MEMBER_LEFT, rltext.UpdateGroup)
EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_GROUP_MEMBER_JOINED, rltext.UpdateGroup)
EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_ZONE_UPDATE, rltext.UpdateGroup)
EVENT_MANAGER:RegisterForEvent(rltext.name, EVENT_GROUP_UPDATE, rltext.UpdateGroup)